// Martin Rheinländer, SS 05

#ifndef LIST
#define LIST

#include<stdlib.h>
#include<iostream>

template<class T>
class ListElement{
public: 
	ListElement* Next;
	ListElement* Prev;
	T Data;  
};

template<class T>
class List{
public:
	List();
       ~List();
        void emptyout();
	int getCardinal(){return Counter;};
	T& operator()(int);
	T& getBotMost(int);
	T& getTopMost(int);
	void insertBotMost(int,const T&);
	void insertTopMost(int,const T&);
	void prepend(const T&);
	void  append(const T&);
	T eraseBotMost(int);
	T eraseTopMost(int);
	int*  sort();
	void print();
private:
	int Counter;
	ListElement<T>* First;
	ListElement<T>* Last; 
	ListElement<T>* Bot;
	ListElement<T>* Top;
}; 

#include"List.hpp"

#endif 


